// Fill out your copyright notice in the Description page of Project Settings.


#include "BountyHunterCharacter.h"

#include "EndlessVendetta/EVGameInstance.h"
#include "Kismet/GameplayStatics.h"

void ABountyHunterCharacter::SpawnMainBounty()
{
	UEVGameInstance* GI = Cast<UEVGameInstance>(GetGameInstance());
	if (!IsValid(GI->MainSaveGameInstanceRef)) return;

	if (GI->MainSaveGameInstanceRef->CurrentMainBountyIndexSave > CurrentMainBountyIndex) CompleteCurrentMainBounty();

	if (MainBountyClasses.IsEmpty() || MainBountyClasses.Num() <= CurrentMainBountyIndex|| !IsValid(MainBountyClasses[CurrentMainBountyIndex]))
	{
		AllBountiesCompleted();
		return;
	}

	CurrentMainBounty = GetWorld()->SpawnActor<AMainBountyClass>(MainBountyClasses[CurrentMainBountyIndex]);
	const FAttachmentTransformRules AttachmentTransformRules(EAttachmentRule::SnapToTarget, true);
	AttachToComponent(GetRootComponent(), AttachmentTransformRules);

	UGameplayStatics::GetCurrentLevelName(GetWorld()) == OpenWorldLevelName ? CurrentMainBounty->SpawnOpenWorldCheckpoint() : CurrentMainBounty->SpawnCheckpoints();
}

void ABountyHunterCharacter::CompleteCurrentMainBounty()
{
	// Collect rewards for bounty and move onto next
	UE_LOG(LogTemp, Warning, TEXT("Would be collecting reward for completing bounty and moving onto next if possible"));
	CurrentMainBountyIndex++;
}

void ABountyHunterCharacter::AllBountiesCompleted()
{
	UE_LOG(LogTemp, Warning, TEXT("Game Completed!!!! No more Bounties left... or you forgot to set a bounty at one of the indexes oof"));
}

void ABountyHunterCharacter::BeginPlay()
{
	if (UGameplayStatics::DoesSaveGameExist("MainSave", 0)) SpawnMainBounty();
	Super::BeginPlay();
}

void ABountyHunterCharacter::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);
}

