// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "BaseGadgetTutorial.h"
#include "EndlessVendetta/GadgetSystem/GadgetManager.h"
#include "RingModuleTutorial.generated.h"

/**
 * 
 */
UCLASS()
class ENDLESSVENDETTA_API ARingModuleTutorial : public ABaseGadgetTutorial
{
	GENERATED_BODY()

	AGadgetManager* GadgetManager;

	void BeginPlay() override;

	void Tick(float DeltaSeconds) override;

protected:
	UPROPERTY(EditDefaultsOnly, Category = "Gadget Tutorial")
	FString HackTargetWaypointDesc;
	UPROPERTY(EditDefaultsOnly, Category = "Gadget Tutorial")
	FString ResultWaypointDesc;
	
	UPROPERTY(BlueprintReadWrite, Category = "Gadget Tutorial")
	FVector HackTargetWaypointLoc;
	UPROPERTY(BlueprintReadWrite, Category = "Gadget Tutorial")
	FVector ResultWaypointLoc;
	
};
